<?php 
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services;

class RelTotalVendasNivelProd  {
    
    protected $relTotalVendasNivelProd;
    protected $utilService;
        
    public function __construct (Services\RelTotalVendasNivelProd $relTotalVendasNivelProd, Utilities\Util $utilService) {
        $this->utilService = $utilService;
        $this->relTotalVendasNivelProd = $relTotalVendasNivelProd;
    }
    
    
    // key is the name in the DataSourceFilter
    // keyName is the name in the Query
    private function setTCDandCDcondition(&$conditions, $key, $keyName) {
        if( !array_key_exists($key, $conditions) ) {
            $conditions['T'.$keyName] = 'T';    
            $conditions[$keyName] = null;
            
        } else {
            $conditions[$keyName] = '_'.implode('_', $conditions[$keyName] ).'_';
            $conditions['T'.$keyName] = null;
            if($key !== $keyName) {
                unset($conditions[$keyName]);
            }
        }
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        set_time_limit(120);
        try {
            
            $conditions = $this->utilService->getParamsAsArray($request);
            $conditions['__is_report'] = ($request->getFilterCriteria()->getPage() === null);
            $conditions['DTVENDAINI'] = $conditions['DTMOVIMENTO'][0];
            $conditions['DTVENDAFIN'] = $conditions['DTMOVIMENTO'][1];
            unset($conditions['DTMOVIMENTO']);
            
            $conditions['CDNVPRODUTO'] = $this->relTotalVendasNivelProd->maxNivProd();
            $this->setTCDandCDcondition($conditions, 'CDFILIAL', 'CDFILIAL');
            $this->setTCDandCDcondition($conditions, 'CDCAIXA', 'CDCAIXA');
            $this->setTCDandCDcondition($conditions, 'CDCLIENTE', 'CDCLIENTE');
            $this->setTCDandCDcondition($conditions, 'CDCONSUMIDOR', 'CDCONSUMIDOR');
            $this->setTCDandCDcondition($conditions, 'CDVENDEDOR', 'CDVENDEDOR');
            
            if( (!array_key_exists('CDARVPRODI', $conditions) || $conditions['CDARVPRODI'] === '0000000000') && 
                !array_key_exists('CDARVPRODF', $conditions) && !array_key_exists('CDARVPROD', $conditions)) {
                $conditions['CDPRODS'] = 
                $conditions['CDARVPRODI'] = 
                $conditions['CDARVPRODF'] = null;     
                $conditions['TCDPRODUTO'] = 'T';
                
            } else {
                if( (!array_key_exists('CDARVPRODI', $conditions) || $conditions['CDARVPRODI'] == '0000000000') && 
                    !array_key_exists('CDARVPRODF', $conditions)) {
                    for($i = 0; $i < count($conditions['CDARVPROD']); $i++) {
                        $produtos[] = $conditions['CDARVPROD'][$i];
                    }
                    
                    $conditions['CDPRODS'] = implode('_', $produtos);
                    $conditions['CDARVPRODI'] = 
                    $conditions['CDARVPRODF'] = null;   
                                             
                   
                } else {
                    $params = array(
                        ':CDPRODINI' =>  str_replace("%", "",$conditions['CDARVPRODI']),
                        ':CDPRODFIM' =>  str_replace("%", "",$conditions['CDARVPRODF'])
                    );

                    $conditions['CDARVPRODI'] = str_replace("%", "",$conditions['CDARVPRODI']);
                    $conditions['CDARVPRODF'] = str_replace("%", "",$conditions['CDARVPRODF']);
                    $conditions['CDPRODS'] = null;  
                }
                
                if(array_key_exists('CDARVPRODI', $conditions) && !array_key_exists('CDARVPRODF', $conditions)) {
                    $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
                }
                
                $conditions['TCDPRODUTO'] = null;
                unset($conditions['NMPRODUTO']);
            }
              if(!array_key_exists('PRODNIV', $conditions)) {
                   $PRODNIV = array("PRODNIV");
                   $conditions['PRODNIV'] = null;
                }
                else{
			    $conditions["TCDPRODUTO"]=null;
                }
            $response->addDataSet(new DataSet ('vnd4120A_relTotalVendasNivelProd', $this->relTotalVendasNivelProd->geraRelatorio($conditions) ) );
            
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
    
    private function getProdutos($params){
        $conditions = '';
        if(!empty($params)){
          $conditions = implode('_', $params);  
        }
        return $conditions;
    }
}