<?php
namespace Teknisa\MAN\Services;

use Doctrine\DBAL\Connection;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class TransfSaldoService extends StoredProcedure {

    protected $entityManager;
	protected $util;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\Util $util, Connection $connection)  {
		parent::__construct($connection, 'ATUALIZA_SALDO_CONS');
		$this->entityManager = $entityManager;
		$this->util = $util;
	}
	
	public function adqSaldoCons($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqSaldoCons, $params);
		return $query;
	}
	
	public function adqTipoRece($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqTipoRece, $params);
		return $query;
	}
	
	public function adqSeqMovExtr($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqSeqMovExtr, $params);
		return $query;
	}
	
	public function acmInsMovExtrato($params){
	    $query = $this->entityManager->getConnection()->executeQuery(self::acmInsMovExtrato, $params);
		return $query;
	}
	
	public function acmUpdate($params){
	    $query = $this->entityManager->getConnection()->executeQuery(self::acmUpdate, $params);
		return $query;
	}
	
    const adqSaldoCons = "SELECT
                            S.CDCLIENTE, 
                            S.CDCONSUMIDOR, 
                            S.CDFAMILISALD, 
                            F.NMFAMILISALD, 
                            S.VRSALDCONFAM
                        FROM SALDOCONS S, FAMILIASALDO F 
                        WHERE (S.CDCLIENTE     = :CDCLIENTE)  AND
                              (S.CDCONSUMIDOR  = :CDCONSUMIDOR)  AND
                              (S.CDFAMILISALD  = :CDFAMILISALD)  AND
                              (S.CDFAMILISALD  = F.CDFAMILISALD) AND
                              (S.NRORG         = :NRORG)         AND
                              (F.NRORG         = :NRORG)      
                         ORDER BY S.CDFAMILISALD";
                         
    const adqSeqMovExtr = "SELECT
                               LPAD((NVL(MAX(NRSEQMOVEXT),0) + 1), 3, '0') as NRSEQMOVEXT
                            FROM
                               EXTRATOCONS
                            WHERE
                               (CDCLIENTE    = :CDCLIENTE)    AND
                               (CDCONSUMIDOR = :CDCONSUMIDOR) AND
                               (CDFAMILISALD = :CDFAMILISALD) AND
                               (DTMOVEXTCONS = :DTMOVEXTCONS) AND
                               (NRORG = :NRORG)";
                         
    const adqTipoRece = "SELECT
                           A.CDTIPORECE
                        FROM
                           (SELECT
                              MIN(CDTIPORECE) AS CDTIPORECE
                           FROM
                              TIPORECE
                           WHERE
                              IDTIPORECE = '4' AND
                              NRORG = :NRORG) A";
                              
    const acmInsMovExtrato = "INSERT INTO EXTRATOCONS
                                 (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, DTMOVEXTCONS, NRSEQMOVEXT, CDTIPORECE,
                                  DSOPEEXTCONS, VRMOVEXTCONS, VRSALDCONEXT, IDTPMOVEXT, DTULTATUEXT, NRSEQREGCREDVND,
                                  IDIMPEXTRATO)
                              VALUES
                                 (:CDCLIENTE, :CDCONSUMIDOR, :CDFAMILISALD, :DTMOVEXTCONS, :NRSEQMOVEXT, :CDTIPORECE,
                                  :DSOPEEXTCONS, :VRMOVEXTCONS, :VRSALDCONEXT, :IDTPMOVEXT, SYSDATE, :NRSEQREGCREDVND,
                                  'S')";
                                  
    const acmUpdate = "UPDATE SALDOCONS
                        SET
                          VRSALDCONFAM = :VRSALDCONFAM
                        WHERE
                          CDCLIENTE = :CDCLIENTE AND
                          CDCONSUMIDOR = :CDCONSUMIDOR AND
                          CDFAMILISALD = :CDFAMILISALD";
}